diff --git a/sys/vfs/nfs/nfs_vnops.c b/sys/vfs/nfs/nfs_vnops.c
index 1e1e284..656190b 100644
--- a/sys/vfs/nfs/nfs_vnops.c
+++ b/sys/vfs/nfs/nfs_vnops.c
@@ -826,7 +826,7 @@ nfs_setattrrpc(struct vnode *vp, struct vattr *vap,
 		np->n_modestamp = 0;
 		nfsm_wcc_data(vp, wccflag);
 	} else
-		nfsm_loadattr(vp, (struct vattr *)0);
+		nfsm_loadattr(vp, NULL);
 	m_freem(mrep);
 nfsmout:
 	return (error);
@@ -1041,7 +1041,7 @@ nfs_lookup(struct vop_old_lookup_args *ap)
 			nfsm_postop_attr(newvp, attrflag, NFS_LATTR_NOSHRINK);
 			nfsm_postop_attr(dvp, attrflag, NFS_LATTR_NOSHRINK);
 		} else
-			nfsm_loadattr(newvp, (struct vattr *)0);
+			nfsm_loadattr(newvp, NULL);
 		*vpp = newvp;
 		m_freem(mrep);
 		if (!lockparent) {
@@ -1088,7 +1088,7 @@ nfs_lookup(struct vop_old_lookup_args *ap)
 		nfsm_postop_attr(newvp, attrflag, NFS_LATTR_NOSHRINK);
 		nfsm_postop_attr(dvp, attrflag, NFS_LATTR_NOSHRINK);
 	} else
-		nfsm_loadattr(newvp, (struct vattr *)0);
+		nfsm_loadattr(newvp, NULL);
 #if 0
 	/* XXX MOVE TO nfs_nremove() */
 	if ((cnp->cn_flags & CNP_MAKEENTRY) &&
@@ -1240,7 +1240,7 @@ nfs_readrpc(struct vnode *vp, struct uio *uiop)
 			nfsm_dissect(tl, u_int32_t *, 2 * NFSX_UNSIGNED);
 			eof = fxdr_unsigned(int, *(tl + 1));
 		} else
-			nfsm_loadattr(vp, (struct vattr *)0);
+			nfsm_loadattr(vp, NULL);
 		nfsm_strsiz(retlen, nmp->nm_rsize);
 		nfsm_mtouio(uiop, retlen);
 		m_freem(mrep);
@@ -1357,7 +1357,7 @@ nfs_writerpc(struct vnode *vp, struct uio *uiop, int *iomode, int *must_commit)
 				}
 			}
 		} else {
-			nfsm_loadattr(vp, (struct vattr *)0);
+			nfsm_loadattr(vp, NULL);
 		}
 		m_freem(mrep);
 		if (error)
@@ -1386,8 +1386,8 @@ nfs_mknodrpc(struct vnode *dvp, struct vnode **vpp, struct componentname *cnp,
 	u_int32_t *tl;
 	caddr_t cp;
 	int32_t t1, t2;
-	struct vnode *newvp = (struct vnode *)0;
-	struct nfsnode *np = (struct nfsnode *)0;
+	struct vnode *newvp = NULL;
+	struct nfsnode *np = NULL;
 	struct vattr vattr;
 	char *cp2;
 	caddr_t bpos, dpos;
@@ -1437,7 +1437,7 @@ nfs_mknodrpc(struct vnode *dvp, struct vnode **vpp, struct componentname *cnp,
 		if (!gotvp) {
 			if (newvp) {
 				vput(newvp);
-				newvp = (struct vnode *)0;
+				newvp = NULL;
 			}
 			error = nfs_lookitup(dvp, cnp->cn_nameptr,
 			    cnp->cn_namelen, cnp->cn_cred, cnp->cn_td, &np);
@@ -1492,8 +1492,8 @@ nfs_create(struct vop_old_create_args *ap)
 	u_int32_t *tl;
 	caddr_t cp;
 	int32_t t1, t2;
-	struct nfsnode *np = (struct nfsnode *)0;
-	struct vnode *newvp = (struct vnode *)0;
+	struct nfsnode *np = NULL;
+	struct vnode *newvp = NULL;
 	caddr_t bpos, dpos, cp2;
 	int error = 0, wccflag = NFSV3_WCCRATTR, gotvp = 0, fmode = 0;
 	struct mbuf *mreq, *mrep, *md, *mb, *mb2;
@@ -1548,7 +1548,7 @@ again:
 		if (!gotvp) {
 			if (newvp) {
 				vput(newvp);
-				newvp = (struct vnode *)0;
+				newvp = NULL;
 			}
 			error = nfs_lookitup(dvp, cnp->cn_nameptr,
 			    cnp->cn_namelen, cnp->cn_cred, cnp->cn_td, &np);
@@ -1911,7 +1911,7 @@ nfs_symlink(struct vop_old_symlink_args *ap)
 	caddr_t bpos, dpos, cp2;
 	int slen, error = 0, wccflag = NFSV3_WCCRATTR, gotvp;
 	struct mbuf *mreq, *mrep, *md, *mb, *mb2;
-	struct vnode *newvp = (struct vnode *)0;
+	struct vnode *newvp = NULL;
 	int v3 = NFS_ISV3(dvp);
 
 	nfsstats.rpccnt[NFSPROC_SYMLINK]++;
@@ -2005,8 +2005,8 @@ nfs_mkdir(struct vop_old_mkdir_args *ap)
 	caddr_t cp;
 	int32_t t1, t2;
 	int len;
-	struct nfsnode *np = (struct nfsnode *)0;
-	struct vnode *newvp = (struct vnode *)0;
+	struct nfsnode *np = NULL;
+	struct vnode *newvp = NULL;
 	caddr_t bpos, dpos, cp2;
 	int error = 0, wccflag = NFSV3_WCCRATTR;
 	int gotvp = 0;
@@ -2051,7 +2051,7 @@ nfsmout:
 	if (error == EEXIST || (!error && !gotvp)) {
 		if (newvp) {
 			vrele(newvp);
-			newvp = (struct vnode *)0;
+			newvp = NULL;
 		}
 		error = nfs_lookitup(dvp, cnp->cn_nameptr, len, cnp->cn_cred,
 			cnp->cn_td, &np);
@@ -2557,7 +2557,7 @@ nfs_readdirplusrpc(struct vnode *vp, struct uio *uiop)
 				dpos = dpossav1;
 				mdsav2 = md;
 				md = mdsav1;
-				nfsm_loadattr(newvp, (struct vattr *)0);
+				nfsm_loadattr(newvp, NULL);
 				dpos = dpossav2;
 				md = mdsav2;
 				dp->nfs_type =
@@ -2678,7 +2678,7 @@ nfs_sillyrename(struct vnode *dvp, struct vnode *vp, struct componentname *cnp)
 
 	/* Try lookitups until we get one that isn't there */
 	while (nfs_lookitup(dvp, sp->s_name, sp->s_namlen, sp->s_cred,
-		cnp->cn_td, (struct nfsnode **)0) == 0) {
+		cnp->cn_td, NULL) == 0) {
 		sp->s_name[4]++;
 		if (sp->s_name[4] > 'z') {
 			error = EINVAL;
@@ -2714,7 +2714,7 @@ nfs_lookitup(struct vnode *dvp, const char *name, int len, struct ucred *cred,
 	u_int32_t *tl;
 	caddr_t cp;
 	int32_t t1, t2;
-	struct vnode *newvp = (struct vnode *)0;
+	struct vnode *newvp = NULL;
 	struct nfsnode *np, *dnp = VTONFS(dvp);
 	caddr_t bpos, dpos, cp2;
 	int error = 0, fhlen, attrflag;
@@ -2762,7 +2762,7 @@ nfs_lookitup(struct vnode *dvp, const char *name, int len, struct ucred *cred,
 				return (ENOENT);
 			}
 		} else
-			nfsm_loadattr(newvp, (struct vattr *)0);
+			nfsm_loadattr(newvp, NULL);
 	}
 	m_freem(mrep);
 nfsmout:
@@ -3004,7 +3004,7 @@ nfs_flush(struct vnode *vp, int waitfor, struct thread *td, int commit)
 				 * We have to be able to break out if this 
 				 * is an 'intr' mount.
 				 */
-				if (nfs_sigintr(nmp, (struct nfsreq *)0, td)) {
+				if (nfs_sigintr(nmp, NULL, td)) {
 					error = -EINTR;
 					break;
 				}
diff --git a/sys/vfs/nfs/nfsm_subs.h b/sys/vfs/nfs/nfsm_subs.h
index 23a9809..bc78b4f 100644
--- a/sys/vfs/nfs/nfsm_subs.h
+++ b/sys/vfs/nfs/nfsm_subs.h
@@ -192,7 +192,7 @@ struct mbuf *nfsm_rpchead (struct ucred *cr, int nmflag, int procid,
 				nfsm_adv(NFSX_V3FATTR); \
 		} \
 		if (f) \
-			nfsm_loadattr((v), (struct vattr *)0); \
+			nfsm_loadattr((v), NULL); \
 	} while (0)
 
 #define nfsm_getfh(f, s, v3) \
@@ -227,7 +227,7 @@ struct mbuf *nfsm_rpchead (struct ucred *cr, int nmflag, int procid,
 		nfsm_dissect(tl, u_int32_t *, NFSX_UNSIGNED); \
 		if (((f) = fxdr_unsigned(int, *tl)) != 0) { \
 			if ((t1 = nfs_loadattrcache(&ttvp, &md, &dpos, \
-				(struct vattr *)0, lflags)) != 0) { \
+				NULL, lflags)) != 0) { \
 				error = t1; \
 				(f) = 0; \
 				m_freem(mrep); \
diff --git a/sys/vfs/nwfs/nwfs_vnops.c b/sys/vfs/nwfs/nwfs_vnops.c
index 2514d12..1faaaae 100644
--- a/sys/vfs/nwfs/nwfs_vnops.c
+++ b/sys/vfs/nwfs/nwfs_vnops.c
@@ -400,7 +400,7 @@ nwfs_create(struct vop_old_create_args *ap)
 	struct vattr *vap = ap->a_vap;
 	struct vnode **vpp=ap->a_vpp;
 	struct componentname *cnp = ap->a_cnp;
-	struct vnode *vp = (struct vnode *)0;
+	struct vnode *vp = NULL;
 	int error = 0, fmode;
 	struct vattr vattr;
 	struct nwnode *np;
@@ -595,7 +595,7 @@ nwfs_mkdir(struct vop_old_mkdir_args *ap)
 	int len=cnp->cn_namelen;
 	struct ncp_open_info no;
 	struct nwnode *np;
-	struct vnode *newvp = (struct vnode *)0;
+	struct vnode *newvp = NULL;
 	ncpfid fid;
 	int error = 0;
 	struct vattr vattr;
diff --git a/sys/vfs/ufs/ffs_balloc.c b/sys/vfs/ufs/ffs_balloc.c
index 819e994..670eac4 100644
--- a/sys/vfs/ufs/ffs_balloc.c
+++ b/sys/vfs/ufs/ffs_balloc.c
@@ -241,7 +241,7 @@ ffs_balloc(struct vop_balloc_args *ap)
 	--num;
 	nb = ip->i_ib[indirs[0].in_off];
 	if (nb == 0) {
-		pref = ffs_blkpref(ip, lbn, 0, (ufs_daddr_t *)0);
+		pref = ffs_blkpref(ip, lbn, 0, NULL);
 		/*
 		 * If the filesystem has run out of space we can skip the
 		 * full fsync/undo of the main [fail] case since no undo
@@ -295,7 +295,7 @@ ffs_balloc(struct vop_balloc_args *ap)
 			continue;
 		}
 		if (pref == 0)
-			pref = ffs_blkpref(ip, lbn, 0, (ufs_daddr_t *)0);
+			pref = ffs_blkpref(ip, lbn, 0, NULL);
 		if ((error =
 		    ffs_alloc(ip, lbn, pref, (int)fs->fs_bsize, cred, &newb)) != 0) {
 			brelse(bp);
diff --git a/sys/vfs/ufs/ufs_lookup.c b/sys/vfs/ufs/ufs_lookup.c
index 9a0b4d2..39d4b15 100644
--- a/sys/vfs/ufs/ufs_lookup.c
+++ b/sys/vfs/ufs/ufs_lookup.c
@@ -1132,7 +1132,7 @@ ufs_checkpath(struct inode *source, struct inode *target, struct ucred *cred)
 		}
 		error = vn_rdwr(UIO_READ, vp, (caddr_t)&dirbuf,
 				sizeof (struct dirtemplate), (off_t)0,
-				UIO_SYSSPACE, IO_NODELOCKED, cred, (int *)0);
+				UIO_SYSSPACE, IO_NODELOCKED, cred, NULL);
 		if (error != 0)
 			break;
 #		if (BYTE_ORDER == LITTLE_ENDIAN)
diff --git a/sys/vfs/ufs/ufs_quota.c b/sys/vfs/ufs/ufs_quota.c
index 49da8ac..bcf283f 100644
--- a/sys/vfs/ufs/ufs_quota.c
+++ b/sys/vfs/ufs/ufs_quota.c
@@ -960,7 +960,7 @@ ufs_dqflush(struct vnode *vp)
 			if (dq->dq_cnt)
 				panic("dqflush: stray dquot");
 			LIST_REMOVE(dq, dq_hash);
-			dq->dq_ump = (struct ufsmount *)0;
+			dq->dq_ump = NULL;
 		}
 	}
 }
diff --git a/sys/vm/vm_map.c b/sys/vm/vm_map.c
index 0e994ef..f166a1e 100644
--- a/sys/vm/vm_map.c
+++ b/sys/vm/vm_map.c
@@ -3567,7 +3567,7 @@ DB_SHOW_COMMAND(map, vm_map_print)
 				db_indent += 2;
 				vm_map_print((db_expr_t)(intptr_t)
 					     entry->object.sub_map,
-					     full, 0, (char *)0);
+					     full, 0, NULL);
 				db_indent -= 2;
 			}
 		} else {
@@ -3587,7 +3587,7 @@ DB_SHOW_COMMAND(map, vm_map_print)
 				db_indent += 2;
 				vm_object_print((db_expr_t)(intptr_t)
 						entry->object.vm_object,
-						full, 0, (char *)0);
+						full, 0, NULL);
 				nlines += 4;
 				db_indent -= 2;
 			}
diff --git a/test/stress/fsx/fsx.c b/test/stress/fsx/fsx.c
index fdf4e3a..64c63df 100644
--- a/test/stress/fsx/fsx.c
+++ b/test/stress/fsx/fsx.c
@@ -956,7 +956,7 @@ main(int argc, char **argv)
 	page_size = getpagesize();
 	page_mask = page_size - 1;
 
-	setvbuf(stdout, (char *)0, _IOLBF, 0); /* line buffered stdout */
+	setvbuf(stdout, NULL, _IOLBF, 0); /* line buffered stdout */
 
 	while ((ch = getopt(argc, argv, "b:c:dl:m:no:p:qr:s:t:w:D:LN:OP:RS:W"))
 	       != EOF)
diff --git a/tools/regression/fsx/fsx.c b/tools/regression/fsx/fsx.c
index ec1966e..b75a311 100644
--- a/tools/regression/fsx/fsx.c
+++ b/tools/regression/fsx/fsx.c
@@ -934,7 +934,7 @@ main(int argc, char **argv)
 	page_size = getpagesize();
 	page_mask = page_size - 1;
 
-	setvbuf(stdout, (char *)0, _IOLBF, 0); /* line buffered stdout */
+	setvbuf(stdout, NULL, _IOLBF, 0); /* line buffered stdout */
 
 	while ((ch = getopt(argc, argv, "b:c:dl:m:no:p:qr:s:t:w:D:LN:OP:RS:W"))
 	       != EOF)
diff --git a/usr.bin/chat/chat.c b/usr.bin/chat/chat.c
index 488b160..4cc0502 100644
--- a/usr.bin/chat/chat.c
+++ b/usr.bin/chat/chat.c
@@ -132,7 +132,7 @@ int have_tty_parameters = 0;
 #define set_term_param(param) tcsetattr(0, TCSANOW, param)
 struct termios saved_tty_parameters;
 
-char *abort_string[MAX_ABORTS], *fail_reason = (char *)0,
+char *abort_string[MAX_ABORTS], *fail_reason = NULL,
 	fail_buffer[50];
 int n_aborts = 0, abort_next = 0, timeout_next = 0, echo_next = 0;
 int clear_abort_next = 0;
@@ -1177,7 +1177,7 @@ get_string(char *string)
     char *s = temp, *end = s + STR_LEN;
     char *logged = temp;
 
-    fail_reason = (char *)0;
+    fail_reason = NULL;
 
     if (strlen(string) > STR_LEN) {
 	chat_logf("expect string is too long");
diff --git a/usr.bin/doscmd/AsyncIO.h b/usr.bin/doscmd/AsyncIO.h
index 0649ae3..c9b0958 100644
--- a/usr.bin/doscmd/AsyncIO.h
+++ b/usr.bin/doscmd/AsyncIO.h
@@ -47,4 +47,4 @@ void	_RegisterIO(int, void (*)(int, int, void *, regcontext_t *),
 }
 #endif
 
-#define	_Un_RegisterIO(x) _RegisterIO((x), (void (*))0, (void *)0, (void (*))0)
+#define	_Un_RegisterIO(x) _RegisterIO((x), (void (*))0, NULL, (void (*))0)
diff --git a/usr.bin/doscmd/ParseBuffer.c b/usr.bin/doscmd/ParseBuffer.c
index fada186..87d3ebc 100644
--- a/usr.bin/doscmd/ParseBuffer.c
+++ b/usr.bin/doscmd/ParseBuffer.c
@@ -71,7 +71,7 @@ ParseBuffer(char *obuf, char **av, int mac)
 
                         *a++ = buf;
 			if (a == e) {
-				a[-1] = (char *)0;
+				a[-1] = NULL;
 				return(mac - 1);
 			}
 
@@ -84,6 +84,6 @@ ParseBuffer(char *obuf, char **av, int mac)
                         buf = p;
                 }
         }
-        *a = (char *)0;
+        *a = NULL;
         return(a - av);
 }
diff --git a/usr.bin/doscmd/doscmd.c b/usr.bin/doscmd/doscmd.c
index 7e9b401..d5b3dd1 100644
--- a/usr.bin/doscmd/doscmd.c
+++ b/usr.bin/doscmd/doscmd.c
@@ -67,7 +67,7 @@ int		booting = 0;
 int		raw_kbd = 0;
 int		timer_disable = 0;
 struct timeval	boot_time;
-unsigned long	*ivec = (unsigned long *)0;
+unsigned long	*ivec = NULL;
 
 #ifndef USE_VM86
 #define PRB_V86_FORMAT  0x4242
diff --git a/usr.bin/doscmd/mem.c b/usr.bin/doscmd/mem.c
index bd39a28..3f81663 100644
--- a/usr.bin/doscmd/mem.c
+++ b/usr.bin/doscmd/mem.c
@@ -47,7 +47,7 @@ char	*dosmem;
 /* locals */
 static int	dosmem_size;
 
-static char	*next_p = (char *)0;
+static char	*next_p = NULL;
 static char	*end_p  = (char *)0xB0000L;
 
 static char *
diff --git a/usr.bin/finger/net.c b/usr.bin/finger/net.c
index ae2aee0..17ff188 100644
--- a/usr.bin/finger/net.c
+++ b/usr.bin/finger/net.c
@@ -225,7 +225,7 @@ trying(const struct addrinfo *ai)
 	char buf[NI_MAXHOST];
 
 	if (getnameinfo(ai->ai_addr, ai->ai_addrlen, buf, sizeof buf,
-			(char *)0, 0, NI_NUMERICHOST) != 0)
+			NULL, 0, NI_NUMERICHOST) != 0)
 		return;		/* XXX can't happen */
 
 	printf("Trying %s...\n", buf);
diff --git a/usr.bin/kzip/kzip.c b/usr.bin/kzip/kzip.c
index 861a1d1..f1e38b9 100644
--- a/usr.bin/kzip/kzip.c
+++ b/usr.bin/kzip/kzip.c
@@ -132,7 +132,7 @@ main(int argc, char **argv)
 		close(pipe1[0]); close(pipe1[1]);
 		close(pipe2[0]); close(pipe2[1]);
 		close(fdi); close(fdo);
-		execlp("gzip", "gzip", "-9", "-n", 0);
+		execlp("gzip", "gzip", "-9", "-n", NULL);
 		exit (0);
 	}
 
@@ -204,7 +204,7 @@ main(int argc, char **argv)
 			"/usr/lib/aout/kzhead.o",
 			obj,
 			"/usr/lib/aout/kztail.o",
-			0);
+			NULL);
 		exit(2);
 	}
 
diff --git a/usr.bin/login/login.c b/usr.bin/login/login.c
index 078cd92..554c38b 100644
--- a/usr.bin/login/login.c
+++ b/usr.bin/login/login.c
@@ -649,7 +649,7 @@ main(int argc, char **argv)
 		err(1, "asprintf()");
 	}
 
-	execlp(shell, arg0, (char *)0);
+	execlp(shell, arg0, NULL);
 	err(1, "%s", shell);
 
 	/*
diff --git a/usr.bin/netstat/inet.c b/usr.bin/netstat/inet.c
index 53dab5d..c6984ce 100644
--- a/usr.bin/netstat/inet.c
+++ b/usr.bin/netstat/inet.c
@@ -797,7 +797,7 @@ icmp_stats(u_long off __unused, char *name, int af __unused)
 #undef p2
 	mib[3] = ICMPCTL_MASKREPL;
 	len = sizeof i;
-	if (sysctl(mib, 4, &i, &len, (void *)0, 0) < 0)
+	if (sysctl(mib, 4, &i, &len, NULL, 0) < 0)
 		return;
 	printf("\tICMP address mask responses are %sabled\n", 
 	       i ? "en" : "dis");
diff --git a/usr.bin/netstat/inet6.c b/usr.bin/netstat/inet6.c
index 9ac29a9..558e699 100644
--- a/usr.bin/netstat/inet6.c
+++ b/usr.bin/netstat/inet6.c
@@ -353,7 +353,7 @@ ip6_stats(u_long off __unused, char *name, int af __unused)
 
 	len = sizeof ip6stat;
 	memset(&ip6stat, 0, len);
-	if (sysctl(mib, 4, &ip6stat, &len, (void *)0, 0) < 0)
+	if (sysctl(mib, 4, &ip6stat, &len, NULL, 0) < 0)
 		return;
 	printf("%s:\n", name);
 
@@ -826,7 +826,7 @@ icmp6_stats(u_long off __unused, char *name, int af __unused)
 
 	len = sizeof icmp6stat;
 	memset(&icmp6stat, 0, len);
-	if (sysctl(mib, 4, &icmp6stat, &len, (void *)0, 0) < 0)
+	if (sysctl(mib, 4, &icmp6stat, &len, NULL, 0) < 0)
 		return;
 	printf("%s:\n", name);
 
diff --git a/usr.bin/netstat/iso.c b/usr.bin/netstat/iso.c
index 0c7a614..26348b6 100644
--- a/usr.bin/netstat/iso.c
+++ b/usr.bin/netstat/iso.c
@@ -398,7 +398,7 @@ isonetprint(struct iso_addr *iso, char *sufx, u_short sufxlen, int islocal)
 
 	line =  isonetname(iso);
 	cp = strchr(line, '\0');
-	ihe = (struct iso_hostent *)0;
+	ihe = NULL;
 
 	if( islocal )
 		islocal = 20;
diff --git a/usr.bin/netstat/route.c b/usr.bin/netstat/route.c
index 3c04ce8..03647ee 100644
--- a/usr.bin/netstat/route.c
+++ b/usr.bin/netstat/route.c
@@ -797,7 +797,7 @@ p_rtentry(struct rtentry *rt)
 			time_t expire_time;
 
 			if ((expire_time =
-			    rt->rt_rmx.rmx_expire - time((time_t *)0)) > 0)
+			    rt->rt_rmx.rmx_expire - time(NULL)) > 0)
 				printf(" %*d", wid_expire, (int)expire_time);
 		} else {
 			printf("%*s ", wid_expire, "");
diff --git a/usr.bin/netstat/unix.c b/usr.bin/netstat/unix.c
index 0dd78b8..5ab46be 100644
--- a/usr.bin/netstat/unix.c
+++ b/usr.bin/netstat/unix.c
@@ -116,7 +116,7 @@ unixdomainpr(struct xunpcb *xunp, struct xsocket *so)
 	if (unp->unp_addr)
 		sa = &xunp->xu_addr;
 	else
-		sa = (struct sockaddr_un *)0;
+		sa = NULL;
 
 	if (first) {
 		printf("Active UNIX domain sockets\n");
diff --git a/usr.bin/nfsstat/nfsstat.c b/usr.bin/nfsstat/nfsstat.c
index 0cf198b..e58194e 100644
--- a/usr.bin/nfsstat/nfsstat.c
+++ b/usr.bin/nfsstat/nfsstat.c
@@ -174,7 +174,7 @@ readstats(struct nfsstats *stp)
 		name[0] = CTL_VFS;
 		name[1] = vfc.vfc_typenum;
 		name[2] = NFS_NFSSTATS;
-		if (sysctl(name, 3, stp, &buflen, (void *)0, (size_t)0) < 0) {
+		if (sysctl(name, 3, stp, &buflen, NULL, (size_t)0) < 0) {
 			err(1, "sysctl");
 		}
 	}
diff --git a/usr.bin/quota/quota.c b/usr.bin/quota/quota.c
index d514e85..a3b4b7f 100644
--- a/usr.bin/quota/quota.c
+++ b/usr.bin/quota/quota.c
@@ -310,7 +310,7 @@ showquotas(int type, u_long id, const char *name)
 		    qup->dqblk.dqb_bsoftlimit == 0 &&
 		    qup->dqblk.dqb_bhardlimit == 0)
 			continue;
-		msgi = (char *)0;
+		msgi = NULL;
 		if (qup->dqblk.dqb_ihardlimit &&
 		    qup->dqblk.dqb_curinodes >= qup->dqblk.dqb_ihardlimit)
 			msgi = "File limit reached on";
@@ -321,7 +321,7 @@ showquotas(int type, u_long id, const char *name)
 			else
 				msgi = "Over file quota on";
 		}
-		msgb = (char *)0;
+		msgb = NULL;
 		if (qup->dqblk.dqb_bhardlimit &&
 		    qup->dqblk.dqb_curblocks >= qup->dqblk.dqb_bhardlimit)
 			msgb = "Block limit reached on";
@@ -333,12 +333,12 @@ showquotas(int type, u_long id, const char *name)
 				msgb = "Over block quota on";
 		}
 		if (qflag) {
-			if ((msgi != (char *)0 || msgb != (char *)0) &&
+			if ((msgi != NULL || msgb != NULL) &&
 			    lines++ == 0)
 				heading(type, id, name, "");
-			if (msgi != (char *)0)
+			if (msgi != NULL)
 				printf("\t%s %s\n", msgi, qup->fsname);
-			if (msgb != (char *)0)
+			if (msgb != NULL)
 				printf("\t%s %s\n", msgb, qup->fsname);
 			continue;
 		}
@@ -356,19 +356,19 @@ showquotas(int type, u_long id, const char *name)
 				, nam
 				, (u_long) (dbtob(qup->dqblk.dqb_curblocks)
 					    / 1024)
-				, (msgb == (char *)0) ? ' ' : '*'
+				, (msgb == NULL) ? ' ' : '*'
 				, (u_long) (dbtob(qup->dqblk.dqb_bsoftlimit)
 					    / 1024)
 				, (u_long) (dbtob(qup->dqblk.dqb_bhardlimit)
 					    / 1024)
-				, (msgb == (char *)0) ? ""
+				, (msgb == NULL) ? ""
 				    :timeprt(qup->dqblk.dqb_btime));
 			printf("%8lu%c%7lu%8lu%8s\n"
 				, (u_long)qup->dqblk.dqb_curinodes
-				, (msgi == (char *)0) ? ' ' : '*'
+				, (msgi == NULL) ? ' ' : '*'
 				, (u_long)qup->dqblk.dqb_isoftlimit
 				, (u_long)qup->dqblk.dqb_ihardlimit
-				, (msgi == (char *)0) ? ""
+				, (msgi == NULL) ? ""
 				    : timeprt(qup->dqblk.dqb_itime)
 			);
 			continue;
@@ -441,7 +441,7 @@ getprivs(long id, int quotatype)
 	struct statfs *fst;
 	int nfst, i;
 
-	qup = quphead = (struct quotause *)0;
+	qup = quphead = NULL;
 
 	nfst = getmntinfo(&fst, MNT_NOWAIT);
 	if (nfst == 0)
diff --git a/usr.bin/rdist/Makefile b/usr.bin/rdist/Makefile
index f751429..5645c20 100644
--- a/usr.bin/rdist/Makefile
+++ b/usr.bin/rdist/Makefile
@@ -6,7 +6,7 @@ PROG=	rdist
 SRCS=	docmd.c expand.c gram.y lookup.c main.c rshrcmd.c server.c
 CFLAGS+=-I${.CURDIR}
 YFLAGS=
-WARNS?=	0
+WARNS?=	2
 
 # To use the old method, which requires setuid-root and all the baggage and
 # security holes that goes with it, uncomment:
diff --git a/usr.bin/rdist/server.c b/usr.bin/rdist/server.c
index 4a59700..3f6bdf4 100644
--- a/usr.bin/rdist/server.c
+++ b/usr.bin/rdist/server.c
@@ -1360,7 +1360,7 @@ dospecial(char *cmd)
 		close(fd[1]);
 		setgid(groupid);
 		setuid(userid);
-		execl(_PATH_BSHELL, "sh", "-c", cmd, 0);
+		execl(_PATH_BSHELL, "sh", "-c", cmd, NULL);
 		_exit(127);
 	}
 	close(fd[1]);
diff --git a/usr.bin/systat/ifstat.c b/usr.bin/systat/ifstat.c
index 27c8d9f..b700886 100644
--- a/usr.bin/systat/ifstat.c
+++ b/usr.bin/systat/ifstat.c
@@ -259,7 +259,7 @@ fetchifstat(void)
 		old_outb = ifp->if_mib.ifmd_data.ifi_obytes;
 		ifp->tv_lastchanged = ifp->if_mib.ifmd_data.ifi_lastchange;
 
-		if (gettimeofday(&new_tv, (struct timezone *)0) != 0)
+		if (gettimeofday(&new_tv, NULL) != 0)
 			IFSTAT_ERR(2, "error getting time of day");
 		(void)getifmibdata(ifp->if_row, &ifp->if_mib);
 
diff --git a/usr.bin/systat/main.c b/usr.bin/systat/main.c
index 43b5640..969fbf4 100644
--- a/usr.bin/systat/main.c
+++ b/usr.bin/systat/main.c
@@ -91,7 +91,7 @@ main(int argc, char **argv)
 			p = lookup(&argv[0][1]);
 			if (p == (struct cmdtab *)-1)
 				errx(1, "%s: ambiguous request", &argv[0][1]);
-			if (p == (struct cmdtab *)0)
+			if (p == NULL)
 				errx(1, "%s: unknown request", &argv[0][1]);
 			curcmd = p;
 		} else {
diff --git a/usr.bin/talk/init_disp.c b/usr.bin/talk/init_disp.c
index 50bd3b8..582abfc 100644
--- a/usr.bin/talk/init_disp.c
+++ b/usr.bin/talk/init_disp.c
@@ -76,9 +76,9 @@ init_display(void)
 
 	if (initscr() == NULL)
 		errx(1, "Terminal type unset or lacking necessary features.");
-	(void) sigaction(SIGTSTP, (struct sigaction *)0, &sa);
+	(void) sigaction(SIGTSTP, NULL, &sa);
 	sigaddset(&sa.sa_mask, SIGALRM);
-	(void) sigaction(SIGTSTP, &sa, (struct sigaction *)0);
+	(void) sigaction(SIGTSTP, &sa, NULL);
 	curses_initialized = 1;
 	clear();
 	refresh();
diff --git a/usr.bin/talk/invite.c b/usr.bin/talk/invite.c
index b1b0a16..d6c8d4b 100644
--- a/usr.bin/talk/invite.c
+++ b/usr.bin/talk/invite.c
@@ -87,7 +87,7 @@ invite_remote(void)
 	 * so we can use the interupt timer to resend the invitation
 	 */
 	end_msgs();
-	setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
+	setitimer(ITIMER_REAL, &itimer, NULL);
 	message("Waiting for your party to respond");
 	signal(SIGALRM, re_invite);
 	(void) setjmp(invitebuf);
diff --git a/usr.bin/talk/msgs.c b/usr.bin/talk/msgs.c
index cc82d12..ee9fa53 100644
--- a/usr.bin/talk/msgs.c
+++ b/usr.bin/talk/msgs.c
@@ -64,7 +64,7 @@ start_msgs(void)
 	signal(SIGALRM, disp_msg);
 	itimer.it_value.tv_sec = itimer.it_interval.tv_sec = MSG_INTERVAL;
 	itimer.it_value.tv_usec = itimer.it_interval.tv_usec = 0;
-	setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
+	setitimer(ITIMER_REAL, &itimer, NULL);
 }
 
 void
@@ -74,6 +74,6 @@ end_msgs(void)
 
 	timerclear(&itimer.it_value);
 	timerclear(&itimer.it_interval);
-	setitimer(ITIMER_REAL, &itimer, (struct itimerval *)0);
+	setitimer(ITIMER_REAL, &itimer, NULL);
 	signal(SIGALRM, SIG_DFL);
 }
diff --git a/usr.bin/telnet/commands.c b/usr.bin/telnet/commands.c
index e17a487..079d324 100644
--- a/usr.bin/telnet/commands.c
+++ b/usr.bin/telnet/commands.c
@@ -1314,14 +1314,14 @@ shell(int argc, char *argv[] __unused)
 	    else
 		shellname++;
 	    if (argc > 1)
-		execl(shellp, shellname, "-c", &saveline[1], (char *)0);
+		execl(shellp, shellname, "-c", &saveline[1], NULL);
 	    else
-		execl(shellp, shellname, (char *)0);
+		execl(shellp, shellname, NULL);
 	    perror("Execl");
 	    _exit(1);
 	}
     default:
-	    (void)wait((int *)0);	/* Wait for the shell to complete */
+	    (void)wait(NULL);	/* Wait for the shell to complete */
 
 	    if (TerminalWindowSize(&newrows, &newcols) && connected &&
 		(err_ || ((oldrows != newrows) || (oldcols != newcols)))) {
@@ -2411,7 +2411,7 @@ help(int argc, char *argv[])
 		c = getcmd(arg);
 		if (Ambiguous((void *)c))
 			printf("?Ambiguous help command %s\n", arg);
-		else if (c == (Command *)0)
+		else if (c == NULL)
 			printf("?Invalid help command %s\n", arg);
 		else
 			printf("%s\n", c->help);
diff --git a/usr.bin/telnet/network.c b/usr.bin/telnet/network.c
index 94a7794..336dec9 100644
--- a/usr.bin/telnet/network.c
+++ b/usr.bin/telnet/network.c
@@ -86,7 +86,7 @@ stilloob(void)
     do {
 	FD_ZERO(&excepts);
 	FD_SET(net, &excepts);
-	value = select(net+1, (fd_set *)0, (fd_set *)0, &excepts, &timeout);
+	value = select(net+1, NULL, NULL, &excepts, &timeout);
     } while ((value == -1) && (errno == EINTR));
 
     if (value < 0) {
diff --git a/usr.bin/telnet/sys_bsd.c b/usr.bin/telnet/sys_bsd.c
index e1664ca..f05fb10 100644
--- a/usr.bin/telnet/sys_bsd.c
+++ b/usr.bin/telnet/sys_bsd.c
@@ -306,7 +306,7 @@ tcval(int func)
     case SLC_BRK:
     case SLC_EOR:
     default:
-	return((cc_t *)0);
+	return(NULL);
     }
 }
 
@@ -963,7 +963,7 @@ process_rings(int netin, int netout, int netex, int ttyin, int ttyout, int poll)
     if (netex)
 	FD_SET(net, xbitsp);
     if ((c = select(maxfd + 1, ibitsp, obitsp, xbitsp,
-	     (poll == 0)? (struct timeval *)0 : &TimeValue)) < 0) {
+	     (poll == 0)? NULL : &TimeValue)) < 0) {
 	if (c == -1) {
 		    /*
 		     * we can get EINTR if we are in line mode,
diff --git a/usr.bin/tftp/main.c b/usr.bin/tftp/main.c
index 334acef..f2237b3 100644
--- a/usr.bin/tftp/main.c
+++ b/usr.bin/tftp/main.c
@@ -688,7 +688,7 @@ help(int argc, char **argv)
 		c = getcmd(arg);
 		if (c == (struct cmd *)-1)
 			printf("?Ambiguous help command %s\n", arg);
-		else if (c == (struct cmd *)0)
+		else if (c == NULL)
 			printf("?Invalid help command %s\n", arg);
 		else
 			printf("%s\n", c->help);
diff --git a/usr.bin/tip/libacu/acucommon.c b/usr.bin/tip/libacu/acucommon.c
index f1317ae..e5c3441 100644
--- a/usr.bin/tip/libacu/acucommon.c
+++ b/usr.bin/tip/libacu/acucommon.c
@@ -97,11 +97,11 @@ void acu_nap (unsigned int how_long)
         setvec(vec, acunap_napx);
         ringring = 0;
         (void) sigvec(SIGALRM, &vec, &ovec);
-        (void) setitimer(ITIMER_REAL, itp, (struct itimerval *)0);
+        (void) setitimer(ITIMER_REAL, itp, NULL);
         while (!ringring)
 					sigpause(omask &~ mask(SIGALRM));
-        (void) sigvec(SIGALRM, &ovec, (struct sigvec *)0);
-        (void) setitimer(ITIMER_REAL, &oitv, (struct itimerval *)0);
+        (void) sigvec(SIGALRM, &ovec, NULL);
+        (void) setitimer(ITIMER_REAL, &oitv, NULL);
 				(void) sigsetmask(omask);
 }
 
diff --git a/usr.bin/tip/tip/cmds.c b/usr.bin/tip/tip/cmds.c
index 7dda90c..9d12fbf 100644
--- a/usr.bin/tip/tip/cmds.c
+++ b/usr.bin/tip/tip/cmds.c
@@ -751,7 +751,7 @@ shell(void)
 		else
 			cp++;
 		shell_uid();
-		execl(value(SHELL), cp, 0);
+		execl(value(SHELL), cp, NULL);
 		printf("\r\ncan't execl!\r\n");
 		exit(1);
 	}
@@ -849,7 +849,7 @@ execute(char *s)
 	else
 		cp++;
 	shell_uid();
-	execl(value(SHELL), cp, "-c", s, 0);
+	execl(value(SHELL), cp, "-c", s, NULL);
 }
 
 static int
@@ -1028,7 +1028,7 @@ expand(char *name)
 		close(pivec[1]);
 		close(2);
 		shell_uid();
-		execl(Shell, Shell, "-c", cmdbuf, 0);
+		execl(Shell, Shell, "-c", cmdbuf, NULL);
 		_exit(1);
 	}
 	if (pid == -1) {
diff --git a/usr.bin/tip/tip/remcap.c b/usr.bin/tip/tip/remcap.c
index 9ed2de1..aa4721f 100644
--- a/usr.bin/tip/tip/remcap.c
+++ b/usr.bin/tip/tip/remcap.c
@@ -94,7 +94,7 @@ tgetent(bp, name)
 	int rc1, rc2;
 
 	remotefile = cp = getenv(V_TERMCAP);
-	if (cp == (char *)0 || strcmp(cp, _PATH_REMOTE) == 0) {
+	if (cp == NULL || strcmp(cp, _PATH_REMOTE) == 0) {
 		remotefile = cp = _PATH_REMOTE;
 		return (getent(bp, name, cp));
 	} else {
@@ -140,7 +140,7 @@ getent(bp, name, cp)
 	if (cp && *cp) {
 		if (*cp!='/') {
 			cp2 = getenv(V_TERM);
-			if (cp2 == (char *)0 || strcmp(name,cp2) == 0) {
+			if (cp2 == NULL || strcmp(name,cp2) == 0) {
 				strcpy(bp,cp);
 				return (tnchktc());
 			} else
diff --git a/usr.bin/window/cmd4.c b/usr.bin/window/cmd4.c
index 402b0aa..dc2fe0f 100644
--- a/usr.bin/window/cmd4.c
+++ b/usr.bin/window/cmd4.c
@@ -51,6 +51,6 @@ c_colon()
 	wwputc('\n', cmdwin);
 	wwcurtowin(cmdwin);
 	setterse(oldterse);
-	if (dolongcmd(buf, (struct value *)0, 0) < 0)
+	if (dolongcmd(buf, NULL, 0) < 0)
 		error("Out of memory.");
 }
diff --git a/usr.bin/window/lcmd1.c b/usr.bin/window/lcmd1.c
index 3e03ede..e072777 100644
--- a/usr.bin/window/lcmd1.c
+++ b/usr.bin/window/lcmd1.c
@@ -182,7 +182,7 @@ struct value *v, *a;
 	v->v_num = selwin ? selwin->ww_id + 1 : -1;
 	if (a->v_type == V_ERR)
 		return;
-	if ((w = vtowin(a, (struct ww *)0)) == 0)
+	if ((w = vtowin(a, NULL)) == 0)
 		return;
 	setselwin(w);
 }
@@ -334,10 +334,10 @@ struct value *a;
 	struct ww *w;
 
 	if (a->v_type == V_STR && str_match(a->v_str, "all", 3))
-		closewin((struct ww *)0);
+		closewin(NULL);
 	else
 		for (; a->v_type != V_ERR; a++)
-			if ((w = vtowin(a, (struct ww *)0)) != 0)
+			if ((w = vtowin(a, NULL)) != 0)
 				closewin(w);
 }
 
diff --git a/usr.bin/window/lcmd2.c b/usr.bin/window/lcmd2.c
index 608a8b3..6e723f5 100644
--- a/usr.bin/window/lcmd2.c
+++ b/usr.bin/window/lcmd2.c
@@ -119,7 +119,7 @@ struct value *a;
 		return;
 	}
 
-	(void) gettimeofday(&timeval, (struct timezone *)0);
+	(void) gettimeofday(&timeval, NULL);
 	timeval.tv_sec -= starttime.tv_sec;
 	if ((timeval.tv_usec -= starttime.tv_usec) < 0) {
 		timeval.tv_sec--;
@@ -339,7 +339,7 @@ l_alias(v, a)
 				for (p = vp->v_str; *q++ = *p++;)
 					;
 			q[-1] = 0;
-			if ((ap = alias_set(a[0].v_str, (char *)0)) == 0) {
+			if ((ap = alias_set(a[0].v_str, NULL)) == 0) {
 				p_memerror();
 				str_free(str);
 				return;
diff --git a/usr.bin/window/main.c b/usr.bin/window/main.c
index 5e78e42..7f0c435 100644
--- a/usr.bin/window/main.c
+++ b/usr.bin/window/main.c
@@ -116,7 +116,7 @@ char **argv;
 	default_shell[1] = 0;
 	default_nline = NLINE;
 	default_smooth = 1;
-	(void) gettimeofday(&starttime, (struct timezone *)0);
+	(void) gettimeofday(&starttime, NULL);
 	(void) setlocale(LC_CTYPE, "");
 	if (wwinit() < 0) {
 		(void) fprintf(stderr, "%s.\n", wwerror());
@@ -178,7 +178,7 @@ char **argv;
 	setterse(tflag);
 	setcmd(1);
 	if (cmd != 0)
-		(void) dolongcmd(cmd, (struct value *)0, 0);
+		(void) dolongcmd(cmd, NULL, 0);
 	if (!fflag)
 		if (dflag || doconfig() < 0)
 			dodefault();
diff --git a/usr.bin/window/win.c b/usr.bin/window/win.c
index 18ea04b..68580b7 100644
--- a/usr.bin/window/win.c
+++ b/usr.bin/window/win.c
@@ -92,7 +92,7 @@ char *shf, **sh;
 	 * addwin() puts w at the top, so we don't waste an
 	 * insert and delete operation.
 	 */
-	setselwin((struct ww *)0);
+	setselwin(NULL);
 	addwin(w, 0);
 	setselwin(w);
 	if (wwspawn(w, shf, sh) < 0) {
diff --git a/usr.bin/window/wwchild.c b/usr.bin/window/wwchild.c
index 632efc5..419ed3b 100644
--- a/usr.bin/window/wwchild.c
+++ b/usr.bin/window/wwchild.c
@@ -54,7 +54,7 @@ wwchild()
 
 	olderrno = errno;
 	while ((pid =
-	    wait3((int *)&w, WNOHANG|WUNTRACED, (struct rusage *)0)) > 0) {
+	    wait3((int *)&w, WNOHANG|WUNTRACED, NULL)) > 0) {
 		for (wp = wwindex; wp < &wwindex[NWW]; wp++) {
 			if (*wp && (*wp)->ww_state == WWS_HASPROC
 			    && (*wp)->ww_pid == pid) {
diff --git a/usr.bin/window/wwenviron.c b/usr.bin/window/wwenviron.c
index ac0648c..912366a 100644
--- a/usr.bin/window/wwenviron.c
+++ b/usr.bin/window/wwenviron.c
@@ -62,7 +62,7 @@ register struct ww *wp;
 #ifndef TIOCSCTTY
 	if ((i = open("/dev/tty", 0)) < 0)
 		goto bad;
-	if (ioctl(i, TIOCNOTTY, (char *)0) < 0)
+	if (ioctl(i, TIOCNOTTY, NULL) < 0)
 		goto bad;
 	(void) close(i);
 #endif
diff --git a/usr.bin/window/wwiomux.c b/usr.bin/window/wwiomux.c
index baf9e94..ecf87bd 100644
--- a/usr.bin/window/wwiomux.c
+++ b/usr.bin/window/wwiomux.c
@@ -118,7 +118,7 @@ wwiomux()
 			tv.tv_usec = 10000;
 		}
 		wwnselect++;
-		n = select(n + 1, &imask, (fd_set *)0, (fd_set *)0, &tv);
+		n = select(n + 1, &imask, NULL, NULL, &tv);
 		wwsetjmp = 0;
 		noblock = 0;
 
diff --git a/usr.bin/window/wwtty.c b/usr.bin/window/wwtty.c
index 5883834..59a6cc6 100644
--- a/usr.bin/window/wwtty.c
+++ b/usr.bin/window/wwtty.c
@@ -155,7 +155,7 @@ wwstoptty(d)
 	/* not guaranteed to work on the pty side */
 	if (tcflow(d, TCOOFF) < 0)
 #else
-	if (ioctl(d, TIOCSTOP, (char *)0) < 0)
+	if (ioctl(d, TIOCSTOP, NULL) < 0)
 #endif
 	{
 		wwerrno = WWE_SYS;
@@ -170,7 +170,7 @@ wwstarttty(d)
 	/* not guaranteed to work on the pty side */
 	if (tcflow(d, TCOON) < 0)
 #else
-	if (ioctl(d, TIOCSTART, (char *)0) < 0)
+	if (ioctl(d, TIOCSTART, NULL) < 0)
 #endif
 	{
 		wwerrno = WWE_SYS;
